
##这个function是决定选取几个PCA factor的
## X是scale之后的matrix
## nmax: the maximum number of PCA factor that you want to limit

baing=function(X, nmax){
  kmax=min(ncol(X),nmax)
  X=as.matrix(X)
  T=nrow(X)
  N=ncol(X)
  NT=N*T
  NT1=N+T
  CT=matrix(0,1,kmax)
  ii=1:kmax
  GCT=min(N,T)
  CT[1,]=(NT1/NT)*log(min(N,T))*ii
  
  
  if(T<N){
    Xvalue=X%*%t(X)
    svd_X=svd(Xvalue, nu=nrow(Xvalue), nv=ncol(Xvalue))
    ev=svd_X$u
    eigval=diag(svd_X$d,nrow(Xvalue),ncol(Xvalue))
    Fhat0=sqrt(T)*ev
    Lambda0=t(X)%*%Fhat0/T
    
  }else{
    Xvalue=t(X)%*%X
    svd_X=svd(Xvalue, nu=nrow(Xvalue), nv=ncol(Xvalue))
    ev=svd_X$u
    eigval=diag(svd_X$d,nrow(Xvalue),ncol(Xvalue))
    Lambda0=sqrt(N)*ev
    Fhat0=X%*%Lambda0/N
  }
  
  
  Sigma=matrix(0,1,kmax+1)
  IC1=matrix(0,nrow(CT),kmax+1)
  
  for (i in kmax:1) {
    Fhat=Fhat0[,1:i]
    lambda=Lambda0[,1:i]
    chat=Fhat%*%t(lambda)
    ehat=X-chat
    Sigma[i]=mean(sum(ehat*ehat/T))
    IC1[,i]=log(Sigma[i])+CT[,i]
  }## end i
  
  Sigma[kmax+1]=mean(sum(X*X/T))
  IC1[,kmax+1]=log(Sigma[kmax+1])
  min_index=which.min(IC1)
  if (kmax<min_index){ic1=kmax
  }else{ic1=min_index}
  ic1

}## end of the whole function


###########################################################################################################################
##这个function是做PCA的: N < T
## X是matrix, 并且是scale之后的
## nfac: the number of PC factor that you want to get

PCA_baing=function(X,nfac){
  N=ncol(X)
  Xvalue=t(X)%*%X
  svd_X=svd(Xvalue,nu=nrow(Xvalue), nv=ncol(Xvalue))
  U=svd_X$u
  S=diag(svd_X$d,nrow(Xvalue),ncol(Xvalue))
  lambda=U[,1:nfac]*sqrt(N)
  fhat=X%*%lambda/N
  fhat
  
}## end of the whole function





















